<?php

namespace FiloBlu\Refilo\Console\Command;

use FiloBlu\Refilo\Model\Exporter\Categories;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Input\InputOption;
use Symfony\Component\Console\Output\OutputInterface;

/**
 * Class SomeCommand
 */
class ImportCategories extends Command
{
    const NAME = 'name';
    /**
     * @var Categories
     */
    private $categories;


    /**
     * ImportBlocks constructor.
     * @param Categories $categoriesBlock
     * @param string $name
     */
    public function __construct(
        Categories $categoriesBlock,
        string $name = null
    ) {
        $this->categories = $categoriesBlock;
        parent::__construct($name);
    }

    /**
     * @inheritDoc
     */
    protected function configure()
    {
        $options = [
            new InputOption(
                self::NAME,
                null,
                InputOption::VALUE_REQUIRED,
                'Name'
            )
        ];

        $this->setName('refilo:sync:categories');
        $this->setDescription('Import Categories');
        $this->setDefinition($options);

        parent::configure();
    }

    /**
     * Execute the command
     *
     * @param InputInterface $input
     * @param OutputInterface $output
     *
     * @return void
     */
    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $this->categories->exportCategories();
        $output->writeln('<info>Success.</info>');
    }
}
